#version 330 core

layout(location = 0) in vec3 position;
layout(location = 1) in vec3 normal;
layout(location = 2) in vec2 uv;

out vec2 fragmentUV;
out vec3 fragmentNormal;
out vec3 worldPos;
out vec4 lightSpacePos;

uniform mat4 model;
uniform mat4 view_proj;
uniform mat4 view;
uniform mat4 light_view_proj;

void main()
{
	//For converting homogenous coordinates to texture coordinates
	mat4 biasMatrix;
	biasMatrix[0]= vec4(0.5, 0.0, 0.0, 0.0);
	biasMatrix[1]= vec4(0.0, 0.5, 0.0, 0.0);
	biasMatrix[2]= vec4(0.0, 0.0, 0.5, 0.0);
	biasMatrix[3]= vec4(0.5, 0.5, 0.5, 1.0);

	fragmentUV = uv;
		gl_Position = view_proj * model * vec4(position, 1);
		lightSpacePos = light_view_proj * model*  vec4(position, 1);
		fragmentNormal = (model * vec4(normal, 0.0)).xyz;
		worldPos = (model * vec4(position, 1.0)).xyz;
	
}