#version 330 core

layout(triangles) in;

// 1 triangle per cubemap face = 6 triangles with 3 vertices each = 18
layout(triangle_strip, max_vertices=18) out;

// transformation from world space to cubemap face
uniform mat4 cubemapMat[6];

out vec4 WorldSpacePosFromGeomShader;

void main(void) {

	for(gl_Layer = 0; gl_Layer < 6; ++gl_Layer) {
	
		for(int triangleVertex = 0; triangleVertex < 3; ++triangleVertex) {
		
			WorldSpacePosFromGeomShader  = gl_in[triangleVertex].gl_Position;
			gl_Position = cubemapMat[gl_Layer] * WorldSpacePosFromGeomShader;
			EmitVertex();
		
		}
		EndPrimitive();
	}

}