#version 440

uniform struct Matrices
{
	mat4 mProj;
	mat4 mView;
} matrices;

uniform vec3 vQuad1, vQuad2;
uniform int rowss;
uniform int cols;

layout(points) in;
layout(triangle_strip) out;
layout(max_vertices = 4) out;

in vec3 vColorPass[];
in float fLifeTimePass[];
in float fSizePass[];
in int iTypePass[];
in int iTexPosPass[];

smooth out vec2 vTexCoord;
flat out vec4 vColorPart;
flat out int type;
void main()
{
	gl_Position = vec4(0);

type = iTypePass[0];
  if(iTypePass[0] != 0)
  {
    vec3 vPosOld = gl_in[0].gl_Position.xyz;
    float fSize = fSizePass[0];
    mat4 mVP = matrices.mProj*matrices.mView;
    
    vColorPart = vec4(vColorPass[0], fLifeTimePass[0]);
       
    int col = iTexPosPass[0] % cols;
    int row = iTexPosPass[0] / rowss;
    float textXOffset = float(col) / float(cols) ;
    float textYOffset = float(row) / float(rowss);
   
    vec3 vPos = vPosOld+(-vQuad1-vQuad2)*fSize;
    vTexCoord = vec2(0.0, 0.0);
	vTexCoord.x = vTexCoord.x / cols + textXOffset;
	vTexCoord.y = vTexCoord.y / rowss + textYOffset;

    gl_Position = mVP*vec4(vPos, 1.0);
    EmitVertex();
    
    vPos = vPosOld+(-vQuad1+vQuad2)*fSize;
    vTexCoord = vec2(0.0, 1.0);
	vTexCoord.x = vTexCoord.x / cols + textXOffset;
	vTexCoord.y = vTexCoord.y / rowss + textYOffset;
    gl_Position = mVP*vec4(vPos, 1.0);
    EmitVertex();
    
    vPos = vPosOld+(vQuad1-vQuad2)*fSize;
    vTexCoord = vec2(1.0, 0.0);
	vTexCoord.x = vTexCoord.x / cols + textXOffset;
	vTexCoord.y = vTexCoord.y / rowss + textYOffset;
    gl_Position = mVP*vec4(vPos, 1.0);
    EmitVertex();
    
    vPos = vPosOld+(vQuad1+vQuad2)*fSize;
    vTexCoord = vec2(1.0, 1.0);
	vTexCoord.x = vTexCoord.x / cols + textXOffset;
	vTexCoord.y = vTexCoord.y / rowss + textYOffset;
    gl_Position = mVP*vec4(vPos, 1.0);
    EmitVertex();
      
    EndPrimitive();
  }
}